-- If you want to play with these scripts, please contact me to obtain
-- the database.  breanna at tf3604 dot com. Or keep watching the session
-- page; I am going to try to figure out a way to script out a smaller
-- version of it on there.

use Housing;
go

select fm.FloorMaterialId, fm.HouseId, fm.MaterialName, fm.ActiveDate, fm.InactiveDate
from dbo.FloorMaterial fm
where fm.HouseId <= 10
order by fm.HouseId, fm.InactiveDate;

select top(100)
	fm.FloorMaterialId, fm.HouseId, fm.MaterialName, fm.ActiveDate, fm.InactiveDate
from dbo.FloorMaterial fm
where fm.InactiveDate = '9999-12-31'
order by fm.HouseId;

select fm.HouseId
from dbo.FloorMaterial fm
where fm.InactiveDate = '9999-12-31'
group by fm.HouseId
having count(*) > 1
order by fm.HouseId;

select 	fm.HouseId, fm.MaterialName, fm.ActiveDate, fm.InactiveDate,
	row_number() over (partition by fm.HouseId order by fm.ActiveDate desc) rn
from dbo.FloorMaterial fm
where fm.ActiveDate <= getdate()
and fm.InactiveDate >= getdate();

------------------------------------------------------------
-- Begin test - Round 1
------------------------------------------------------------
drop table if exists #Round1;

select	fm.HouseId, fm.MaterialName
into #Round1
from
(
	select 	fm.HouseId, fm.MaterialName,
		row_number() over (partition by fm.HouseId order by fm.ActiveDate desc) rn
	from dbo.FloorMaterial fm
	where fm.ActiveDate <= getdate()
	and fm.InactiveDate >= getdate()
) fm
where fm.rn = 1
order by fm.HouseId;

------------------------------------------------------------
-- Begin test - Round 2
------------------------------------------------------------
drop table if exists #Round2;

select	fm.HouseId, fm.MaterialName
into #Round2
from
(
	select 	fm.HouseId, fm.MaterialName,
		row_number() over (partition by fm.HouseId order by fm.ActiveDate desc) rn
	from dbo.FloorMaterial fm
	where fm.ActiveDate <= getdate()
	and fm.InactiveDate >= getdate()
) fm
where fm.rn = 1
order by fm.HouseId;

------------------------------------------------------------
-- Compare
------------------------------------------------------------
select *
from #Round1 r1
join #Round2 r2 on r1.HouseId = r2.HouseId
where r1.MaterialName != r2.MaterialName;

------------------------------------------------------------
-- Let's fix it!
-- Begin test - Round 1
------------------------------------------------------------
drop table if exists #Round1;

select	fm.HouseId, fm.MaterialName
into #Round1
from
(
	select 	fm.HouseId, fm.MaterialName,
		row_number() over (partition by fm.HouseId order by fm.ActiveDate desc, fm.FloorMaterialId) rn
	from dbo.FloorMaterial fm
	where fm.ActiveDate <= getdate()
	and fm.InactiveDate >= getdate()
) fm
where fm.rn = 1
order by fm.HouseId;

------------------------------------------------------------
-- Begin test - Round 2
------------------------------------------------------------
drop table if exists #Round2;

select	fm.HouseId, fm.MaterialName
into #Round2
from
(
	select 	fm.HouseId, fm.MaterialName,
		row_number() over (partition by fm.HouseId order by fm.ActiveDate desc, fm.FloorMaterialId) rn
	from dbo.FloorMaterial fm
	where fm.ActiveDate <= getdate()
	and fm.InactiveDate >= getdate()
) fm
where fm.rn = 1
order by fm.HouseId;

------------------------------------------------------------
-- Compare
------------------------------------------------------------
select *
from #Round1 r1
join #Round2 r2 on r1.HouseId = r2.HouseId
where r1.MaterialName != r2.MaterialName;
