drop table if exists #MLB2019RegularSeason;
create table #MLB2019RegularSeason
(
	ID int not null identity(1,1),
	TeamName nvarchar(40) not null,
	League nvarchar(10) not null,
	Division nvarchar(10) not null,
	Wins int not null,
	Losses int not null
);

insert #MLB2019RegularSeason (TeamName, League, Division, Wins, Losses)
values
('New York Yankees','American','East',103,59),
('Tampa Bay Rays','American','East',96,66),
('Boston Red Sox','American','East',84,78),
('Toronto Blue Jays','American','East',67,95),
('Baltimore Orioles','American','East',54,108),
('Minnesota Twins','American','Central',101,61),
('Cleveland Indians','American','Central',93,69),
('Chicago White Sox','American','Central',72,89),
('Kansas City Royals','American','Central',59,103),
('Detroit Tigers','American','Central',47,114),
('Houston Astros','American','West',107,55),
('Oakland Athletics','American','West',97,65),
('Texas Rangers','American','West',78,84),
('Los Angeles Angels','American','West',72,90),
('Seattle Mariners','American','West',68,94),
('Atlanta Braves','National','East',97,65),
('Washington Nationals','National','East',93,69),
('New York Mets','National','East',86,76),
('Philadelphia Phillies','National','East',81,81),
('Miami Marlins','National','East',57,105),
('St. Louis Cardinals','National','Central',91,71),
('Milwaukee Brewers','National','Central',89,73),
('Chicago Cubs','National','Central',84,78),
('Cincinnati Reds','National','Central',75,87),
('Pittsburgh Pirates','National','Central',69,93),
('Los Angeles Dodgers','National','West',106,56),
('Arizona Diamondbacks','National','West',85,77),
('San Francisco Giants','National','West',77,85),
('Colorado Rockies','National','West',71,91),
('San Diego Padres','National','West',70,92);

-- Use the WINDOW clause
select TeamName, Wins, Losses,	
	row_number() over win as TeamRowNumber,
	rank() over win as TeamRank,
	dense_rank() over win as TeamDenseRank
from #MLB2019RegularSeason
window win as (order by Wins desc)
order by ID;

-- Nested WINDOW clauses
select TeamName, League, Division, Wins, Losses,	
	row_number() over WinOrder as OverallRowNumber,
	row_number() over WinLeague as LeagueRowNumber,
	row_number() over WinDivision as DivisionRowNumber
from #MLB2019RegularSeason
window WinOrder as (order by Wins desc),
	WinLeague as (WinOrder partition by League),
	WinDivision as (WinOrder partition by League, Division)
order by League, Division, ID;
